# Task Manager App V2

## Setup
**MongoDB Setup**

1.) Install Mongodb Community (zip)
https://www.mongodb.com/try/download/community

2.) Unzip and move to `C:/Users/<user>` Directory

3.) Run this command on VS Command Line to Initialize MongoDB Connection [NEEDED FOR THE APP TO RUN]

```
C:/Users/<user>/mongodb/bin/mongod.exe --dbpath=C:/Users/<user>/mongodb-data
```
**Config dotenv**
1. Create a Directory in the Root Project Directory named `/config`
2. Create (2) files named: `dev.env` and `test.env`
3. Populate Said Scripts with Keys Needed:

**dev.env**
```
PORT=3000
SENDGRID_API_KEY=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
MONGODB_URL=mongodb://127.0.0.1:27017/task-manager-api
JWT_SECRET=thisisasecretformyapp
```

**test.env**
```
PORT=3000
SENDGRID_API_KEY=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
MONGODB_URL=mongodb://127.0.0.1:27017/task-manager-api-test
JWT_SECRET=thisisasecretformyapp
```

**Install Node Dependencies**
```
npm install
``` 

**Run Dev Server** 
```
npm run dev
``` 

**Run Unit Tests** 
```
npm run test
``` 

**Access the Web App**

Most functionalities are limited to `POSTMAN` since endpoints were the major topics included in this Application. 

Web Application is running on
```
localhost:3000
```


## USAGE
User must need to create a user and login first before accessing endpoints. 
They can also just access their data, and not the data of other users.

**Setting Postman Enviroment Variables**

`url` = localhost:3000

`authtoken`: Coded to tests for Create User and Login User Endpoints

**Create User - Tests Tab on POSTMAN**
```
if(pm.response.code === 201){
    pm.environment.set('authToken', pm.response.json().token)
}
```

**Login User - Tests Tab on POSTMAN**
```
if(pm.response.code === 200){
    pm.environment.set('authToken', pm.response.json().token)
}
```

## Endpoints
**[POST] Create User**

{{url}}/users
```
Sample request data:

{
    "name": "John Doe",
    "email": "johndoe.ancheta@gmail.com",
    "password": "testing123",
    "age": 21
}
```

**[POST] Login User**

{{url}}/users
```
Sample request data:

{
    "email": "johndoe.ancheta@gmail.com",
    "password": "testing123"
}
```

**[POST] Logout User**

{{url}}/users/logout

**[POST] Logout All Users**

{{url}}/users/logoutAll

**[POST] Create Task**

{{url}}/tasks
```
Sample request data:

{
    "description": "task_one",
    "completed": false
}
```

**[GET] Read Profile**

{{url}}/users/me

**[GET] Read User**

{{url}}/users/63e724174002fa440481eda7

**[DEL] Delete User**

{{url}}/users/me

**[GET] Read Tasks**
{{url}}/tasks?sortBy=createdAt:asc

```
Available Queries

// GET /tasks?completed=true
// GET /tasks?limit=10&skip=0
// GET /tasks?sortBy=createdAt:desc
```

**[GET] Read Task**

{{url}}/tasks/63e71a0a430a6224bcdf0c7b

**[DEL] Delete Task**

{{url}}/tasks/63e7247b95b55b09f8fef2b3

**[PATCH] Update User**

{{url}}/users/me
```
{
    "age": 27,
    "name": "Mikey",
    "password": "testing123"
}
```

**[PATCH] Update Task**

{{url}}/tasks/63e7247b95b55b09f8fef2b3
```
{
    "completed": false
}
```

**[POST] Upload Avatar**

{{url}}/users/me/avatar
KEY: avatar      Value: img.jpg

**[DELETE] Delete Avatar**
{{url}}/users/me/avatar

**Access the User Avatar through Browser**
http://localhost:3000/users/63e724174002fa440481eda7/avatar
